﻿using AWS.APG.CQRSES.Common;
using AWS.APG.CQRSES.Common.Data;
using System;
using System.Collections.Generic;

namespace AWS.APG.CQRSES.Command
{
    /// <summary>
    /// This is a command model that conatins all write interfaces.
    /// </summary>
    public class CustomerCommandObject
    {
        private int _customerId = 1000;
        private static CustomerData _data;

        public CustomerCommandObject()
        {
            if (_data == null) _data = new CustomerData();
        }

        public int Create(CustomerEntity entity)
        {
            _customerId += 1;
            //insert code here
            entity.Id = _customerId;

            _data.Customers().Add(entity);
            
            
            //--code to add in message bus/queue goes here
            

            return _customerId;
        }

        public void Update(CustomerEntity entity)
        {
            var customer = _data.Customers().Find(c => c.Id == entity.Id);


            //update code here
            if (customer != null)
            {
                customer.CompanyName = entity.CompanyName;
                customer.Address = entity.Address;
                customer.Firstname = entity.Firstname;
                customer.Lastname = entity.Lastname;
                customer.VIP = entity.VIP;

                //--code to add in message bus/queue goes here
            }
        }


        public void Delete(int customerId)
        {
            var customer = _data.Customers().Find(c => c.Id == customerId);

            //Delete code here
            if (customer != null)
            {
                _data.Customers().Remove(customer);
                //--code to add in message bus/queue goes here
            }
        }

        public int AddPoints(int customerId, int points)
        {
            int rewardId = Helper.GetRewardId();

            //Add points here
            _data.CustomerRewards().Add(new CustomerRewardPointEntity() { 
                Id = rewardId,
                CustomerId = customerId,
                Points = points,
                Timestamp = DateTime.Now
            });

            //--code to add in message bus/queue goes here

            return rewardId; 
        }

        public int RedeemPoints(int customerId, int points)
        {
            int rewardId = Helper.GetRewardId();

            //Redeem points
            _data.CustomerRewards().Add(new CustomerRewardPointEntity()
            {
                Id = rewardId,
                CustomerId = customerId,
                Points = -1 * points,
                Timestamp = DateTime.Now
            });

            //--code to add in message bus/queue goes here

            return rewardId;
        }
    }
}
