﻿using AWS.APG.CQRSES.Command;
using AWS.APG.CQRSES.Common;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

// For more information on enabling Web API for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

namespace AWS.APG.CQRSES.CommandMicroservice.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class CustomerController : ControllerBase
    {

        private CustomerCommandObject _command;
        private readonly ILogger<CustomerController> _logger;

        public CustomerController(ILogger<CustomerController> logger)
        {
            _logger = logger;
            _command = new CustomerCommandObject();
        }


        // POST api/<CustomerController>
        [HttpPost]
        public void Post([FromBody] CustomerEntity value)
        {
            try
            {
                //-- other transformation and/or validation here

                var id = _command.Create(value);
            }

            catch (Exception ex)
            {
                //-- logging goes here
                _logger.LogError(ex, "Post Error");
            }
        }

        // PUT api/<CustomerController>/5
        [HttpPut("{id}")]
        public void Put(int id, [FromBody] CustomerEntity value)
        {
            try
            {
                //-- other transformation and/or validation here

                value.Id = id;
                _command.Update(value);
            }

            catch (Exception ex)
            {
                //-- logging goes here
                _logger.LogError(ex, "Post Error");
            }
        }

        // DELETE api/<CustomerController>/5
        [HttpDelete("{id}")]
        public void Delete(int id)
        {
            try
            {
                _command.Delete(id);
            }

            catch (Exception ex)
            {
                //-- logging goes here
                _logger.LogError(ex, "Post Error");
            }
        }
    }
}
