﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Linq;

namespace AWS.APG.CQRSES.Common.Data
{
    /// <summary>
    /// In memory storage for demo only. This represent a database table for customers and rewards.
    /// </summary>
    public class CustomerData
    {

        #region Mock Customer table

        private List<CustomerEntity> _customers;

        public List<CustomerEntity> Customers()
        {
            if (_customers != null && _customers.Count > 0)
                return _customers;

            _customers = new List<CustomerEntity>()
            {
                new CustomerEntity(){ Id = 1, Address="Metro Manila, Philippines", CompanyName="ABC Company", Firstname="Richard", Lastname="Roe", VIP= false },
                new CustomerEntity(){ Id = 2, Address="Sydney, Australia", CompanyName="LMN Company", Firstname="Arnav", Lastname="Desai", VIP= true },
                new CustomerEntity(){ Id = 3, Address="Kuala Lumpur, Malaysia", CompanyName="XYZ Company", Firstname="Shirley", Lastname="Rodriquez", VIP= true }
            };

            return _customers;
        }

        #endregion


        #region Mock Customer list view

        private List<CustomerEntityList> _customerList;

        public List<CustomerEntityList> CustomerList()
        {
            if (_customerList != null && _customerList.Count > 0)
                return _customerList;

            var result = from customer in Customers()
                    select new CustomerEntityList() 
                    { 
                        Id= customer.Id, 
                        Firstname = customer.Firstname, 
                        Lastname = customer.Lastname, 
                        VIP = customer.VIP
                    };

            _customerList = new List<CustomerEntityList>(result);

            return _customerList;
        }

        #endregion


        #region Mock Customer rewards table

        private List<CustomerRewardPointEntity> _customerRewards;

        public List<CustomerRewardPointEntity> CustomerRewards()
        {
            if (_customerRewards != null && _customerRewards.Count > 0)
                return _customerRewards;

            _customerRewards = new List<CustomerRewardPointEntity>()
            {
                new CustomerRewardPointEntity()
                {
                    Id = 22001,
                    CustomerId = 1,
                    Points = 25,
                    Timestamp = DateTime.Now
                },

                new CustomerRewardPointEntity()
                {
                    Id = 22002,
                    CustomerId = 1,
                    Points = 80,
                    Timestamp = DateTime.Now
                },

                new CustomerRewardPointEntity()
                {
                    Id = 22003,
                    CustomerId = 2,
                    Points = 5,
                    Timestamp = DateTime.Now
                },

                new CustomerRewardPointEntity()
                {
                    Id = 22004,
                    CustomerId = 2,
                    Points = 96,
                    Timestamp = DateTime.Now
                },

                new CustomerRewardPointEntity()
                {
                    Id = 22005,
                    CustomerId = 3,
                    Points = 30,
                    Timestamp = DateTime.Now
                },

                new CustomerRewardPointEntity()
                {
                    Id = 22006,
                    CustomerId = 3,
                    Points = 70,
                    Timestamp = DateTime.Now
                },
            };

            return _customerRewards;
        }

        #endregion

    }
}
