﻿using System;
using System.Collections.Generic;
using AWS.APG.CQRSES.Common;
using System.Linq;
using AWS.APG.CQRSES.Common.Data;

namespace AWS.APG.CQRSES.Query
{
    /// <summary>
    /// Contains all query and read operations.
    /// </summary>
    public class CustomerQueryObject
    {

        private static CustomerData _data;

        public CustomerQueryObject()
        {
            if (_data == null) _data = new CustomerData();
        }

        public CustomerEntity GetCustomer(int customerId)
        {
            return _data.Customers()
                .SingleOrDefault(c => c.Id == customerId);
        }

        public List<CustomerEntityList> GetVIPCustomers()
        {
            //Select statement goes here
            
            return new List<CustomerEntityList>(_data.CustomerList()
                .Where(c => c.VIP == true));
        }

        public IList<CustomerEntityList> GetCustomerList()
        {
            //Select statement goes here

            return _data.CustomerList();
        }

        public int GetCustomerPoints(int customerId)
        {
            int points = _data.CustomerRewards()
                .Where(c => c.CustomerId == customerId)
                .Sum(c=> c.Points);

            //Select statement goes here

            return points;
        }

    }
}
