﻿using AWS.APG.CQRSES.Common;
using AWS.APG.CQRSES.Query;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Threading.Tasks;

// For more information on enabling Web API for empty projects, visit https://go.microsoft.com/fwlink/?LinkID=397860

namespace AWS.APG.CQRSES.QueryMicroservice.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class CustomerController : ControllerBase
    {
        private CustomerQueryObject _query;
        private readonly ILogger<CustomerController> _logger;

        public CustomerController(ILogger<CustomerController> logger)
        {
            _logger = logger;
            _query = new CustomerQueryObject();
        }

        // GET: api/<CustomerController>
        [HttpGet]
        public IEnumerable<CustomerEntityList> Get()
        {            
            return _query.GetCustomerList();   
        }

        // GET: api/<CustomerController>/vip
        [HttpGet("vip")]
        public IEnumerable<CustomerEntityList> GetVIPs()
        {
            return _query.GetVIPCustomers();
        }

        // GET api/<CustomerController>/5
        [HttpGet("{id}")]
        public CustomerEntity Get(int id)
        {
            return _query.GetCustomer(id);
        }

        // GET api/<CustomerController>/points/5
        [HttpGet("points/{id}")]
        public int GetRewardPoints(int id)
        {
            return _query.GetCustomerPoints(id);
        }


    }
}
